
!----------------------------------------------------------------------
!  Mon Mar  6 16:06:17 EET 2000
!  Juha Nurmela
!
!  uPD7810 CPU

#ifndef MBUSPROTO /* data part ***************************************/
#define MBUSPROTO '0'

!----------------------------------------------------------------------
!
!  Eveybody SENDS hello
!
!    0 "...." "ANY1" "!" VERSION \4             e.g. TMF1ANY1!TMF1 0.0 etc
!
!  HSN2 SEND each keypress in separate packet.
!
!    0 "ANY1" "HSN2" "M" "." \4         e.g. make of '1'
!    0 "ANY1" "HSN2" "R" "." \4         e.g. repeat of '1'
!
!  HSN2 ACCEPT following packets.
!
!    0 "HSN2" "...." "d" "........" \4  e.g. display "hepokatt"
!    0 "HSN2" "...." "f" "........" \4  e.g. display "  433500"
!    0 "HSN2" "...." "s" ".." \4        e.g. display "99"
!    0 "HSN2" "...." "v" "." \4         e.g. volume setting 0..9
!    0 "HSN2" "...." "l" "s?t?" \4      e.g. lightshow SERV, ALPHA, BACKLIGHT
!
!----------------------------------------------------------------------

mbus_state:  .rs 1   !
mbus_rxwp:   .rs 2   ! points to next free byte
mbus_rxrp:   .rs 2   ! points to next ready, yet unhandled byte
mbus_txptr:  .rs 2   ! current message, if any.

mbus_txmsg:        .rs 32 ! longer than necessary.
mbus_rxmsg:        .rs 32 ! longer than necessary.
mbus_rxidx:        .rs  1

	! mbus receive buffer is aligned at 0xF000...0xF3FF, DONT CHANGE
	.org 0xF000
mbus_rxbuf:  .rs 1024

#else /* text part *******************************************************/

!----------------------------------------------------------------------
	! Note V not valid during exa'ed VA

netfree:
	exa
	mvi A, 0
	mov [mbus_state], A    ! idle state.
	exa
	ei
	reti ! this grows into next slot... which is unused...

serint:
	exa
	exx
	skit INTFSR 
	?jr 1f
	mvi B, 0xFF
	skit ER                ! ER as soon as possible
	?mvi B, 0
	mov A, RXB             ! RXB as soon as possible, too (quite late in fact).
	ora A, B               ! flag for parity error
	lhld [mbus_rxrp]
	dmov EA, HL
	lhld [mbus_rxwp]
	stax [HL]+
	ani H, 0xF3           ; ASSERT(mbus_rxbuf == 0xF000)
	deq EA, HL             ! next write cell coincides unread cell. Full.
	?shld [mbus_rxwp]
1:
	skit INTFST 
	?jr 1f
	lhld [mbus_txptr]
	ldax [HL]+
	eqi A, 0
	?mov TXB, A
	nei A, 0
	?lxi HL, 0
	shld [mbus_txptr]
1:
	exx
	exa
	ei
	reti

!----------------------------------------------------------------------
!
!  
!
no_txmsg: .asciz ""

mbus_init:
	lxi HL, mbus_rxbuf
	shld [mbus_rxrp]
	shld [mbus_rxwp]

	lxi HL, no_txmsg
	shld [mbus_txptr]
	ret

mbus_hello:
	call mbus_constmsg; .ascii "ANY1", MBUSID, "!"; .byte 0
	ret

! must be CALLed

mbus_constmsg:                  ! 51 xstring
	lxi HL, mbus_txmsg
	pop DE
1:
	ldax [DE]+
	nei A, 0
	?jr 1f
	stax [HL]+
	jr 1b
1:
	push DE

	mvi A, 0x04
	stax [HL]+
	mvi A, 0
	stax [HL]+

	jmp mbus_send

mbus_send:

! XXX
1:
	dmov EA, ECNT
	lxi HL, 1000
	dgt EA, HL
	?jr 1b

	lxi HL, mbus_txmsg
	shld [mbus_txptr]
	mvi A, 0
	mov TXB, A

	jmp mbus_drain

mbus_drain:
1:
	lxi EA, 0
	lhld [mbus_txptr]
	deq EA, HL
	?jr 1b
	ret

mbus_getc:
	lhld [mbus_rxwp]
	dmov EA, HL
	lhld [mbus_rxrp]
	dne EA, HL            ! Pointers differ.
	?ret                  ! ?Not, return
	ldax [HL]+
	ani H, 0xF3           ; ASSERT(mbus_rxbuf == 0xF000)
	shld [mbus_rxrp]
	rets                  ! Got a byte, return with SKIP

mbus_process:
1:
    call mbus_getc        ! skip-return with a chr
    ret                   ! When no character, return.
    call mbus_doc
    jr 1b
    
mbus_doc:

    eqi A, 4
    ?jr 1f
    call mbus_newmsg_maybe  ! Check it out when getting \4
    mvi A, 0                ! Also clear out.
1:
    eqi A, 0
    ?jr 1f
    mov [mbus_rxidx], A   ! Rewind to 0 when getting \0 (or \4)
    ret
1:
    mov B, [mbus_rxidx]
    lti B, SIZE(mbus_rxmsg)
    ?ret                     ! Truncate end of giants.
    lxi HL, mbus_rxmsg
    stax [HL+B]
    adi B, 1
    mov [mbus_rxidx], B
    ret

!----------------------------------------------------------------------
mbus_newmsg_maybe:
	lxi HL, mbus_rxmsg
	mov C, [mbus_rxidx]

	lti C, SIZE(mbus_rxmsg)  ! only ok if not truncated.
	?ret
	suinb C, 4+4+1           ! at least HSN2 SNDR C, trailing datalen to C
	?ret

	jmp mbus_newmsg

!----------------------------------------------------------------------
#endif

